var target : Transform;


var xSpeed = 250.0;
var ySpeed = 120.0;
var movSpeed = 250.0;

var yMinLimit = -20;
var yMaxLimit = 80;

var zoomSpeed = 250;
var zoomMin = 1;
var zoomMax = 80;



private var x = 0.0;
private var y = 0.0;

private var distance :float;
private var movX : float;
private var movY : float;
private var distanceBk : float;
private var cameraBk : Vector3;

function Start () {
    var angles = transform.eulerAngles;
    x = angles.y;
    y = angles.x;

    cameraBk = camera.transform.position;
	distance = -cameraBk.z;
    distanceBk = distance;
    // Make the rigid body not change rotation
   	if (rigidbody)
		rigidbody.freezeRotation = true;
}




function LateUpdate () {
    // リセット
    if (Input.GetKeyDown("e")) {
    	transform.rotation =Quaternion.Euler(0, 0, 0);
    	transform.position = Vector3(0,0,distanceBk);
    	target.rotation =Quaternion.Euler(0, 0, 0);
    	target.position = Vector3(0,0,0);
		distance = distanceBk;
    	x=0;
    	y=0;
    	print("ool");
    }
    
    // カメラズーム
    if (Input.GetMouseButton(2) || Input.GetAxis("Mouse ScrollWheel") ) {
	    distance += (Input.GetAxis("Mouse Y") + Input.GetAxis("Mouse ScrollWheel") * 10 ) * zoomSpeed * 0.02;
	    if (distance < zoomMin) distance = zoomMin;
	    if (distance > zoomMax) distance = zoomMax;
    }

	// マウスの移動量をターゲットの移動量とする
    if (target && Input.GetMouseButton(1)) {
        movX = Input.GetAxis("Mouse X")* movSpeed * 0.055;
        movY = Input.GetAxis("Mouse Y")* movSpeed * 0.055;
       if (movX > 0) target.Translate(Vector3.right * movX * Time.deltaTime);
       if (movX < 0) target.Translate(Vector3.left  *-movX * Time.deltaTime);
       if (movY < 0) target.Translate(Vector3.up    *-movY * Time.deltaTime);
       if (movY > 0) target.Translate(Vector3.down  * movY * Time.deltaTime);
 	}
 		
 		
	// マウスの移動量をカメラの回転値と移動値へ変換してカメラを回す
    if (target && Input.GetMouseButton(0)) {
        x += Input.GetAxis("Mouse X") * xSpeed * 0.02;
        y -= Input.GetAxis("Mouse Y") * ySpeed * 0.02;
 		
 		y = ClampAngle(y, yMinLimit, yMaxLimit);
 	}
 		       
    var rotation = Quaternion.Euler(y, x, 0);
    var position = rotation * Vector3(cameraBk.x, cameraBk.y, -distance) + target.position;
        
    transform.rotation = rotation;
    transform.position = position;
    target.LookAt(this.transform);   // ターゲットをカメラの方へ向ける
}





// 上限下限チェック(回転角度が-360～360の間に収まるようにする)
static function ClampAngle (angle : float, min : float, max : float) {
	if (angle < -360)
		angle += 360;
	if (angle > 360)
		angle -= 360;
	return Mathf.Clamp (angle, min, max);
}